# Class CLN1SectionReadableAbstract

java.lang.Object
com.io7m.calino.vanilla.internal.CLN1SectionReadableAbstract

All Implemented Interfaces:
  `CLNSectionReadableType, Closeable, AutoCloseable`

Direct Known Subclasses:
  `CLN1SectionReadableEnd, CLN1SectionReadableImage2D, CLN1SectionReadableImageArray, CLN1SectionReadableImageCube, CLN1SectionReadableImageInfo, CLN1SectionReadableMetadata, CLN1SectionReadableOther`

public abstract class CLN1SectionReadableAbstract extends Object implements CLNSectionReadableType
An abstract readable section.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CLN1SectionReadableAbstract(com.io7m.jbssio.api.BSSReaderRandomAccessType inReader, CLNParseRequest inRequest, CLNFileSectionDescription inDescription)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final void`
  `close()`
  `final CLNSectionDescription`
  `description()`
  `protected final String`
  `errorLimitExceeded(long length, long limit, String limitName)`
  `final CLNFileSectionDescription`
  `fileSectionDescription()`
  `protected final com.io7m.jbssio.api.BSSReaderRandomAccessType`
  `reader()`
  `protected final CLNParseRequest`
  `request()`
  `final SeekableByteChannel`
  `sectionDataChannel()`
  Obtain a readable channel that delivers the data contained within the section.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CLN1SectionReadableAbstract

    protected CLN1SectionReadableAbstract(com.io7m.jbssio.api.BSSReaderRandomAccessType inReader, CLNParseRequest inRequest, CLNFileSectionDescription inDescription)

- ## Method Details

  - ### request

    protected final CLNParseRequest request()

  - ### fileSectionDescription

    public final CLNFileSectionDescription fileSectionDescription()
    Specified by:
      `fileSectionDescription` in interface `CLNSectionReadableType`
    Returns:
      A file section description

  - ### reader

    protected final com.io7m.jbssio.api.BSSReaderRandomAccessType reader()

  - ### description

    public final CLNSectionDescription description()
    Specified by:
      `description` in interface `CLNSectionReadableType`
    Returns:
      A section description

  - ### sectionDataChannel

    public final SeekableByteChannel sectionDataChannel() throws IOException
    Description copied from interface: `CLNSectionReadableType`
    Obtain a readable channel that delivers the data contained within the section.
    Specified by:
      `sectionDataChannel` in interface `CLNSectionReadableType`
    Returns:
      A readable channel
    Throws:
      `IOException` - On errors

  - ### close

    public final void close()
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`

  - ### errorLimitExceeded

    protected final String errorLimitExceeded(long length, long limit, String limitName)